package {
	import flash.display.Graphics;	
	import flash.display.Sprite;	
	import flash.display.MovieClip;
	import flash.events.Event;
	import flash.net.URLLoader;
	import flash.net.URLRequest;
	import flash.text.TextField;
	import flash.xml.XMLDocument;
	import flash.xml.XMLNode;
	
	import com.itechnica.svg.PathToArray;		

	public class SVGDisplayInFlash extends MovieClip {
		
		private static const SVG_DATA_URL:String = "coloredtoucan.svg";
		private static const HOLDER_NAME:String = "holder";
		private static const MESSAGE_NAME:String = "msg";
		
		private var holderMc:MovieClip;
		private var messageTxt:TextField;

		public function SVGDisplayInFlash() {
			initInstance();
		}
		
		private function initInstance():void {
			// trace("SVGDisplayInFlash.initInstance()");
			initStageObjects();
			// testPathToArray();
			getSVGData(SVG_DATA_URL);
		}
		private function initStageObjects():void {
			holderMc = this[HOLDER_NAME] as MovieClip;
			messageTxt = this[MESSAGE_NAME] as TextField;
			// trace("SVGDisplayInFlash.initStageObjects()");
			// trace("\t", holderMc, messageTxt);
		}
		
		private function getSVGData(url:String):void {
			const loader:URLLoader = new URLLoader();
			loader.addEventListener(Event.COMPLETE, onSVGLoaded);
			loader.load(new URLRequest(url));
		}

		private var svg:XMLDocument = new XMLDocument();
		private var conv:PathToArray;
		private var paths:Array;
		private var nPathNodes:Number;
		
		
		private function onSVGLoaded(event:Event):void {
			const loader:URLLoader = event.target as URLLoader;
			const data:String = loader.data as String;
			
			messageTxt.text = "";
			
			svg.ignoreWhite = true;
			svg.parseXML(data);
			paths = svg.firstChild.firstChild.childNodes;
			nPathNodes = paths.length;
			
			getShapes(0);
		}
		
		private function getShapes(iPath:Number):void {
			var dCmds:Array = new Array();
			var d:Array;
			var dp:Array;
		
			conv = new PathToArray(paths[iPath], dCmds);
		
			// draw the shapes in clips in holder movieclip
			// holder.createEmptyMovieClip("p"+iPath, iPath+1);
			
			const drawLayer:Sprite = new Sprite();
			holderMc.addChild(drawLayer);
			const drawTarget:Graphics = drawLayer.graphics;
			
			for (var i:Number=0; i<dCmds.length; i++) {
				d = dCmds[i];
				dp = d[1];
				switch (d[0]) {
					case "F" :
						drawTarget.beginFill(dp[0], dp[1]);
						break;
					case "S" :
						drawTarget.lineStyle(dp[0], dp[1], dp[2]);
						break;
					case "M" :
						drawTarget.moveTo(dp[0], dp[1]);
						break;
					case "L" :
						drawTarget.lineTo(dp[0], dp[1]);
						break;
					case "C" :
						drawTarget.curveTo(dp[0], dp[1], dp[2], dp[3]);
						break;
				}
			}
			// repeat til all paths have been read
			if (++iPath < nPathNodes) getShapes(iPath);
		}

		private function testPathToArray():void {
			const path:String = "<path fill='#ED1C24' d='M261.5,52.3c11.9,3.2-5.2,21,32.9,31.6C288.5,35.5,261.5,52.3,261.5,52.3z' />";
			const foo:XMLDocument = new XMLDocument(path);
			new PathToArray(foo.firstChild, []);
		}
		
	}

}
